;/////////////////////////////////////////////////////////////////////////////////
;//                                                                             //
;//  PROGRAMMA: CIVIL Design - Funzioni eseguibili all'interno di Autocad       //
;//                                                                             //
;//  FILE: QUOTACUR.LSP  Comando per quotare le curve di livello (isoipse)      //
;//                      selezionato il percorso lungo il quale si desidera     //
;//                      inserire i testi di quotatura. Questi saranno scritti  //
;//                      lo stile di testo coorrente e altezza pari alla varia- //
;//                      bile CDCARHTES di CIVIL Design (tenendo conto della    //
;//                      scala di plottaggio definita nel cartiglio)            //
;//                                                                             //
;//  BY:  A. Nini         O.S.: msdos 4.0  LINGUAGGIO: AutoLisp 12.0            //
;//                                                                             //
;//  RELEASE: 1.00     DATA: maggio 1994  AGGIORNAMENTO:  maggio 1994           //
;//                                                                             //
;//  COPYRIGHT    (C)  DIGICORP Ingegneria S.r.l. - 1994                        //
;//                                                                             //
;/////////////////////////////////////////////////////////////////////////////////

;(special '(handle obj tipo pr CDCARDECQ CDCARHTES scarlib interpq))


(defun QUOTACUR ( / pnt1 pnt2 grp ssl j npl sca ent lent pp1 pp2 pint quota ptmp1 ptmp2
		    oldosnap ang tang a90 dt oldlay layer ht codp qtext codv pt piold
		    x1 x2 y1 y2)
	(setvar "CMDECHO" 0)
	;se non c'e` nessun cartiglio planimetria attivo
	(if (and tipo obj handle pr (= (substr tipo 1 4) "CD-P"))
	    (progn
	      (initget 1)
	      (setq pnt1 (getpoint cd-c-string-quotacur-1))  ;;;"\nPrimo punto per la retta di selezione: "))
	      (initget 1)
	      (setq pnt2 (getpoint pnt1 cd-c-string-quotacur-2)) ;;;"\nSecondo punto per la retta di selezione: "))
	      (setq grp (ssget "_C" pnt1 pnt2))
	      (if (and grp (setq ssl (sslength grp)))
		  (progn
		    (setq pnt1 (trans pnt1 1 0)
			  pnt2 (trans pnt2 1 0)
			  pnt1 (list (car pnt1) (cadr pnt1) 0.0)
			  pnt2 (list (car pnt2) (cadr pnt2) 0.0)
		    )
		    ;;(princ (strcat "\nSelezionate " (itoa ssl) " entita` lungo la linea"))
	    		(princ (strcat cd-c-string-quotacur-3 (itoa ssl) cd-c-string-quotacur-4))
		    ; inizializzo i dati
		    (if (not CDCARDECQ) (setq CDCARDECQ 2))
		    (setq j 0 npl 0)
		    ; assegno allo stile di testo corrente il valore dell'altezza = CDCARHTES in base alla scala di plottaggio
		    ; controllo la variabile che gestisce i modi di snap e layer corrente
		    (if (= CDCARHTES 0.0) (setq CDCARHTES 1.0))
		    (setq sca (atof (cdr (nth 4 obj)))
			  ht (/ (* CDCARHTES sca) 1000.0)
;			  dt (/ (* ht 3.0) 5.0)
			  dt (/ (* ht 0) 5.0); messo a zero la distanza dalla curva di livello
			  oldosnap (getvar "OSMODE")
			  oldlay (getvar "CLAYER")
			  tang (getvar "AUNITS")
			  a90 (/ PI 2)
		    )
		    (command-s "_STYLE" "" "" ht "" "" "" "" "")
		    (setvar "OSMODE" 0)
		    (load "libreria")
		    (princ cd-c-string-quotacur-5) ;;"\nAttendere disegno testi di quota...")
		    (while (< j ssl)
			   (setq ent (ssname grp j)
				 lent (entget ent)
			   )
			   (if (= (cdr (assoc 0 lent)) "POLYLINE")
			       (progn
				 (setq codP (cdr (assoc 70 lent)))
				 (if (= codP 2)    ; se la polilinea e` stata curvata la escludo
				     (princ cd-c-string-quotacur-6)   ;;;"\nImpossibile quotare una polilinea curva")
				     ; per gli altri tipi di polilinea
				     (progn
				       (setq pp1 nil pp2 nil pint nil
					     quota (cdr (assoc 10 lent))
					     quota (caddr quota)
					     ;;layer (strcat (cdr (assoc 8 lent)) "-QUOTE")
						layer (strcat (cdr (assoc 8 lent)) cd-c-string-quotacur-7)
					     ent (entnext ent) lent (entget ent)
					     codV (cdr (assoc 70 lent))
				       )
				       (while (= (cdr (assoc 0 lent)) "VERTEX")
					      (if (or (= codP 0)
						      (and (= codP 4) (= codV 8))
						      (= codP 8)
						      (and (= codP 12) (= codV 40))
						  )
						  (progn
  					            (setq pp2 (cdr (assoc 10 lent))
						          ptmp2 (list (car pp2) (cadr pp2) 0.0)
					            )
					            ; se non e` il primo punto in esame
					            (if pp1
						        (progn
						          (setq piold pint
							        pint (inters pnt1 pnt2 ptmp1 ptmp2)
						          )
						          (if (and piold pint)
							      (setq x1 (atof (rtos (car piold) 2 4))
							            x2 (atof (rtos (car pint) 2 4))
							            y1 (atof (rtos (cadr piold) 2 4))
							            y2 (atof (rtos (cadr pint) 2 4))
							      )
						          )
						          ; se la linea interseca questo segmento di curva di livello
						          (if (and pint (or (not piold) (/= x1 x2) (/= y1 y2)))
							      (progn
							         (if (or (= codP 8) (= codP 12)) ; se e` una polilinea 3D
							             (setq quota (interpq pp1 pp2 pint))   ; calcolo la quota con interpolazione
							         )
							         (setq ang (angle pp1 pp2))
							         (if (and (> ang a90) (< ang (+ PI a90)))
							             (setq ang (- ang PI))
							         )
							         (setq pt (polar pint (+ ang a90) dt)
								       pt (trans pt 0 1)
								       pt (list (car pt) (cadr pt) quota)
								       qtext (rtos quota 2 CDCARDECQ)
								     ;  ang (trang ang 3 tang)
							         )
							         (if (/= (getvar "CLAYER") layer)
							             (if (tblsearch "LAYER" layer)
								         (command-s "_LAYER" "_T" layer "_S" layer "")
								         (command-s "_LAYER" "_M" layer "")
							             )
							         )
									 (setq angt (angtos ang))
;							         (command-s "_TEXT" "_C" pt angt qtext)
							         (command-s "_MTEXT" pt "_J" "MC" "_R" angt pt qtext "")
							         (setq npl (1+ npl))
							      )
						          ) ; if pint
						        )
					            ) ; if pp1
					            (setq pp1 pp2 ptmp1 ptmp2)
						  )
						  (setq pp1 nil)
					      ) ;if
					      (setq ent (entnext ent)
						    lent (entget ent)
						    codV (cdr (assoc 70 lent))
					      )
				       ) ; while
				     )
				 ) ; if codP = 2
			       )
			   ) ; if POLYLINE
			   (setq j (1+ j))
		    ) ; while
		    (scarlib)
		    (setq scarlib nil)
		    ; ripristino l'altezza di testo precedente
		    (setvar "OSMODE" oldosnap)
		    (command-s "_LAYER" "_S" oldlay "")
		    (princ (strcat "\n" (itoa npl) cd-c-string-quotacur-8 ))   ;;" quota(e) inserita(e)"))
		  )
		  (princ cd-c-string-quotacur-9) ;;; "\nNessuna isoipsa interseca la linea di quotatura")
	      )
	    )
	    (princ cd-c-string-cd-curvpol-8)   ;;"\nImpossibile eseguire il comando: nessun oggetto planimetria attivo!")
	)
	(setq interpq nil)
	(setvar "CMDECHO" 1)
	(princ)
)

(defun interpq (pp1 pp2 pint / d1 d2 q1 q2 qo)
       (setq qo (caddr pp1)
	     q1 (- (caddr pp2) (caddr pp1))
	     pp1 (list (car pp1) (cadr pp1) 0.0)
	     pp2 (list (car pp2) (cadr pp2) 0.0)
	     pint (list (car pint) (cadr pint) 0.0)
	     d1 (distance pp1 pp2)
	     d2 (distance pp1 pint)
	     q2 (/ (* q1 d2) d1)
	     q2 (+ qo q2)
       )
       (setq q2 q2)
)

